// cotaskmem.cs cominterfacewrapper.cs enums.cs triggertypeunion.cs triggers.cs
using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using HongliangSoft.Utilities.TaskSchedulers.Interop;
namespace HongliangSoft.Utilities.TaskSchedulers {
	///<summary>gK̏i[܂B</summary>
	///<remarks>
	///  <para></para>
	///</remarks>
	[StructLayout(LayoutKind.Sequential, Pack=2)]
	public sealed class TaskTrigger : ICloneable {
		///<summary>
		///݂̓JnɎw肵ăCX^X܂B
		///</summary>
		public TaskTrigger() : this(DateTime.Now) {
		}
		///<summary>
		///Jnw肵ăCX^X܂B
		///</summary>
		///<param name="startDateTime">^XNJnB</param>
		public TaskTrigger(DateTime startDateTime) {
			this.StartDateTime = startDateTime;
		}
		///<summary>^XNACe̗LԂ̎n܂\NƁA^XN̊Jn擾܂͐ݒ肵܂B</summary>
		///<value><see cref="DateTime"/> ̒lB̂A<see cref="DateTime.Year"/>E<see cref="DateTime.Month"/>E<see cref="DateTime.Day"/> ̓̕^XNACe̗LԂ̊JnN\A<see cref="DateTime.Hour"/>E<see cref="DateTime.Minute"/>̓̕^XN̊Jn\܂Bȉ̒Pʂ͖܂B</value>
		///<exception cref="ArgumentOutOfRangeException">1601 NȑO̔Nw肵܂B</exception>
		public DateTime StartDateTime {
			get {
				return new DateTime(this.beginYear, this.beginMonth, this.beginDay, this.startHour, this.startMinute, 0);
			}
			set {
				if (value.Year < 1601)
					throw new ArgumentOutOfRangeException("value", value, "1601 lw肳܂B");
				this.beginYear = (short)value.Year;
				this.beginMonth = (short)value.Month;
				this.beginDay = (short)value.Day;
				this.startHour = (short)value.Hour;
				this.startMinute = (short)value.Minute;
			}
		}
		///<summary>^XNACe̗LԂ̏I\N擾܂͐ݒ肵܂B</summary>
		///<exception cref="ArgumentOutOfRangeException">1601 NȑO̔Nw肵܂B</exception>
		///<value>^XNACe̗LԂ̏IN\ <see cref="DateTime"/> B<see cref="DateTime.Hour"/> ȉ͖܂B</value>
		///<exception cref="ArgumentOutOfRangeException">1601 NȑO̔Nw肵܂B</exception>
		///<remarks>
		///  <para>Ŏw肳ꂽN߂ƁA^XNACe͖ɂȂ܂B̐ݒ́A<see cref="TaskTrigger.Flags"/>  <see cref="TriggerFlags.HasEndDate"/> w肵ĂƂ̂ݗLłB</para>
		///</remarks>
		public DateTime EndDate {
			get {
				return new DateTime(this.endYear, this.endMonth, this.endDay);
			}
			set {
				if (value.Year < 1601)
					throw new ArgumentOutOfRangeException("value", value, "1601 lw肳܂B");
				this.endYear = (short)value.Year;
				this.endMonth = (short)value.Month;
				this.endDay = (short)value.Day;
			}
		}
		///<summary>gǨpԂ擾܂͐ݒ肵܂B</summary>
		///<value>gKĂp鎞Ԃ\ <see cref="TimeSpan"/> BbƂȉ̒l͖܂BftHg <see cref="TimeSpan.Zero"/> łB</value>
		///<exception cref="ArgumentOutOfRangeException">}CiX̒lA܂ 2147483647 i 1491308 j傫lݒ肵܂B</exception>
		///<remarks>
		///  <para>̒ĺA <see cref="WatchInterval"/> Ŏw肵Ԃ傫lłȂ΂Ȃ܂B</para>
		///  <para>gǨpԂƂ́A̈Ӗ܂B
		///    <list type="bullet">
		///      <item><description><see cref="Flags"/>  <see cref="TriggerFlags.KillAtDurationEnd"/> ݒ肳ĂƂA̎Ԃ߂ƁA^XNXPW[̓AvP[V WM_CLOSE bZ[W𑗐M܂BAvP[VEBhEĂȂȂǂŃbZ[W𑗐MłȂꍇAWM_CLOSE 𑗐MĂ 3 o߂ꍇɂ TerminateProcess s܂B</description></item>
		///      <item><description><see cref="WatchInterval"/>  <see cref="TimeSpan.Zero"/> ȊOɐݒ肳ĂƂÃgK <see cref="StartDateTime"/> ɏ]ĔA^XNXPW[ <see cref="TaskDuration"/> ̊Ԃ߂܂ŁA<see cref="WatchInterval"/> Ŏw肳ꂽԊuŃ^XNNĂ邩ǂmF܂B̂Ƃ^XNNĂȂꍇA^XNXPW[Ăу^XNN܂B</description></item>
		///    </list>
		///  </para>
		///</remarks>
		public TimeSpan TaskDuration {
			get {
				long duration = unchecked((uint)this.minutesDuration);
				return TimeSpan.FromMinutes(duration);
			}
			set {
				long ticks = (long)value.TotalMinutes;
				if (ticks < 0 || ticks > int.MaxValue) //ۂɂ͏uint.MaxValue܂Ŏwł邪AITaskTrigger.GetTriggerStringint.MaxValueI[o[ƃ}CiXɂȂ̂
					throw new ArgumentOutOfRangeException("value", value, "}CiX̒lA܂ 2147483647 傫lɂ͂ł܂B");
				this.minutesDuration = (int)ticks;
			}
		}
		///<summary></summary>
		///<value>gǨpԓŁA^XN̋NmF̊Ԋu\ <see cref="TimeSpan"/> BbƂȉ̒l͖܂BftHg <see cref="TimeSpan.Zero"/> łB</value>
		///<exception cref="ArgumentOutOfRangeException">}CiX̒lA܂ 2147483647 i 1491308 j傫lݒ肵܂B</exception>
		///<remarks>
		///  <para>̒ĺA <see cref="TaskDuration"/> Ŏw肵Ԃ菬lłȂ΂Ȃ܂B</para>
		///  <para>ڂ <see cref="TaskDuration"/> ̉QƂĂB</para>
		///</remarks>
		public TimeSpan WatchInterval {
			get {
				long interval = unchecked((uint)this.minutesInterval);
				return TimeSpan.FromMinutes(interval);
			}
			set {
				long ticks = (long)value.TotalMinutes;
				if (ticks < 0 || ticks > int.MaxValue) //ۂɂ͏uint.MaxValue܂Ŏwł邪AITaskTrigger.GetTriggerStringint.MaxValueI[o[ƃ}CiXɂȂ̂
					throw new ArgumentOutOfRangeException("value", value, "}CiX̒lA܂ 2147483647 傫lɂ͂ł܂B");
				this.minutesInterval = (int)ticks;
			}
		}
		///<summary>gK̐U镑\l擾܂͐ݒ肵܂B</summary>
		///<exception cref="InvalidEnumArgumentException">s <see cref="TriggerFlags"/> ̑gݍ킹łB</exception>
		public TriggerFlags Flags {
			get { return this.flags; }
			set {
				if ((int)value < 0 || (int)value > 7)
					throw new InvalidEnumArgumentException("value", (int)value, typeof(TriggerFlags));
				this.flags = value;
			}
		}
		///<summary>
		///̃gKAxLȃgKɐݒ肵܂B
		///</summary>
		public void SetAsOnce() {
			this.triggerType = TriggerType.Once;
		}
		///<summary>
		///̃gKA莞ԃAChԂƂɔgKɐݒ肵܂B
		///</summary>
		///<remarks>
		///  <para>KvȃAChԂ̐ݒ́A<see cref="Task.IdleWait"/> vpeBŐݒ肵܂B</para>
		///  <para>̐ݒ̃gḰA<see cref="StartDateTime"/> vpeBŎw肵 <see cref="DateTime.Hour"/> ȉ̒l𖳎܂B</para>
		///</remarks>
		public void SetAsOnIdle() {
			this.triggerType = TriggerType.OnIdle;
		}
		///<summary>
		///̃gKAVXeNƂɔgKɐݒ肵܂B
		///</summary>
		///<remarks>
		///  <para>̐ݒ̃gḰA<see cref="StartDateTime"/> vpeBŎw肵 <see cref="DateTime.Hour"/> ȉ̒l𖳎܂B</para>
		///</remarks>
		public void SetAsAtSystemStart() {
			this.triggerType = TriggerType.AtSystemStart;
		}
		///<summary>
		///̃gKAOIƂɔgKɐݒ肵܂B
		///</summary>
		///<remarks>
		///  <para>̐ݒ̃gḰA<see cref="StartDateTime"/> vpeBŎw肵 <see cref="DateTime.Hour"/> ȉ̒l𖳎܂B</para>
		///</remarks>
		public void SetAsAtLogon() {
			this.triggerType = TriggerType.AtLogon;
		}
		///<summary>
		///̃gKAɔgKɐݒ肵܂B
		///</summary>
		///<param name="daily">gK̐ݒĂ <see cref="DailyTrigger"/> B</param>
		public void SetAsDaily(DailyTrigger daily) {
			this.union.Daily = daily;
			this.triggerType = TriggerType.Daily;
		}
		///<summary>
		///̃gKAɔgKɐݒ肵܂B
		///</summary>
		///<param name="daysInterval">gKPʂ̊ԊuB</param>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="daysInterval"/> ɁA1 lA܂ 65535 傫lw肳܂B</exception>
		public void SetAsDaily(int daysInterval) {
			this.SetAsDaily(new DailyTrigger(daysInterval));
		}
		///<summary>
		///̃gKAgKɐݒ肵܂B
		///</summary>
		public void SetAsDaily() {
			this.SetAsDaily(new DailyTrigger(1));
		}
		///<summary>
		///̃gKATԂ̔Cӂ̗jɔgKɐݒ肵܂B
		///</summary>
		///<param name="weekly">gK̐ݒĂ <see cref="WeeklyTrigger"/> B</param>
		public void SetAsWeekly(WeeklyTrigger weekly) {
			this.union.Weekly = weekly;
			this.triggerType = TriggerType.Weekly;
		}
		///<summary>
		///̃gKATCӂ̗jɔgKɐݒ肵܂B
		///</summary>
		///<param name="daysOfWeek">gKj̑gݍ킹\ <see cref="DaysOfWeek"/> ̒lB</param>
		///<exception cref="InvalidEnumArgumentException"><paramref name="daysOfWeek"/> ɁA <see cref="DaysOfWeek"/> ̑gݍ킹w肳܂B</exception>
		public void SetAsWeekly(DaysOfWeek daysOfWeek) {
			this.SetAsWeekly(new WeeklyTrigger(1, daysOfWeek));
		}
		///<summary>
		///̃gKATԂ̔Cӂ̗jɔgKɐݒ肵܂B
		///</summary>
		///<param name="weeksInterval">gKTPʂ̊ԊuB</param>
		///<param name="daysOfWeek">gKj̑gݍ킹\ <see cref="DaysOfWeek"/> ̒lB</param>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="weeksInterval"/> ɁA1 lA܂ 65535 傫lw肳܂B</exception>
		///<exception cref="InvalidEnumArgumentException"><paramref name="daysOfWeek"/> ɁA <see cref="DaysOfWeek"/> ̑gݍ킹w肳܂B</exception>
		public void SetAsWeekly(int weeksInterval, DaysOfWeek daysOfWeek) {
			this.SetAsWeekly(new WeeklyTrigger(weeksInterval, daysOfWeek));
		}
		///<summary>
		///̃gKACӂ̌́ACӂ̓tɔgKɐݒ肵܂B
		///</summary>
		///<param name="monthly">gK̐ݒĂ <see cref="MonthlyDateTrigger"/> B</param>
		public void SetAsMonthlyDate(MonthlyDateTrigger monthly) {
			this.union.MonthlyDate = monthly;
			this.triggerType = TriggerType.MonthlyDate;
		}
		///<summary>
		///̃gKACӂ̌́ACӂ̓tɔgKɐݒ肵܂B
		///</summary>
		///<param name="months">gK錎̑gݍ킹\ <see cref="Months"/> ̒lB</param>
		///<param name="enabledDays">gKt񂾔zBzɊ܂܂t𔭓tƂĐݒ肵܂B</param>
		///<exception cref="InvalidEnumArgumentException"><paramref name="months"/>  <see cref="Months"/> ̑gݍ킹łB</exception>
		///<exception cref="ArgumentNullException"><paramref name="enabledDays"/>  null w肳܂B</exception>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="enabledDays"/> ̒ɁA1 菬lA܂ 31 傫l܂܂Ă܂B</exception>
		public void SetAsMonthlyDate(Months months, int[] enabledDays) {
			MonthlyDateTrigger md = new MonthlyDateTrigger();
			md.Months = months;
			md.SetDaysEnabled(enabledDays, true);
			this.SetAsMonthlyDate(md);
		}
		///<summary>
		///̃gKACӂ̌́AT́ACӂ̗jɔgKɐݒ肵܂B
		///</summary>
		///<param name="monthly">gK̐ݒĂ <see cref="MonthlyDayOfWeekTrigger"/> B</param>
		public void SetAsMonthlyDayOfWeek(MonthlyDayOfWeekTrigger monthly) {
			this.union.MonthlyDayOfWeek = monthly;
			this.triggerType = TriggerType.MonthlyDayOfWeek;
		}
		///<summary>
		///̃gKACӂ̌́AT́ACӂ̗jɔgKɐݒ肵܂B
		///</summary>
		///<param name="months">gK錎̑gݍ킹\ <see cref="Months"/> ̒lB</param>
		///<param name="whichWeek">gKT\ <see cref="WhichWeek"/> ̒lB</param>
		///<param name="daysOfWeek">gKj̑gݍ킹\ <see cref="DaysOfWeek"/> ̒lB</param>
		///<exception cref="InvalidEnumArgumentException"><paramref name="months"/>  <see cref="Months"/> ̑gݍ킹łB܂́A<paramref name="whichWeek"/>  <see cref="WhichWeek"/> ̑gݍ킹łB܂́A<paramref name="daysOfWeek"/>  <see cref="DaysOfWeek"/> ̑gݍ킹łB</exception>
		public void SetAsMonthlyDayOfWeek(Months months, WhichWeek whichWeek, DaysOfWeek daysOfWeek) {
			this.SetAsMonthlyDayOfWeek(new MonthlyDayOfWeekTrigger(months, whichWeek, daysOfWeek));
		}

		///<summary>݂̃gK̃^Cv擾܂B</summary>
		public TriggerType TriggerType {
			get { return this.triggerType; }
		}
		///<summary>
		///<see cref="TaskTrigger.TriggerType"/>  <see cref="TaskSchedulers.TriggerType.Daily"/> ̂ƂȀi[Ă <see cref="DailyTrigger"/> 擾܂B
		///</summary>
		///<exception cref="InvalidOperationException">݂ <see cref="TaskTrigger.TriggerType"/>  <see cref="TaskSchedulers.TriggerType.Daily"/> ł͂܂B</exception>
		///<returns>gK̏i[ <see cref="DailyTrigger"/> B</returns>
		public DailyTrigger GetAsDaily() {
			if (this.TriggerType != TriggerType.Daily)
				throw new InvalidOperationException("݂̃gK^Cv TriggerType.Daily ł͂܂B");
			return this.union.Daily;
		}
		///<summary>
		///<see cref="TaskTrigger.TriggerType"/>  <see cref="TaskSchedulers.TriggerType.Weekly"/> ̂ƂȀi[Ă <see cref="WeeklyTrigger"/> 擾܂B
		///</summary>
		///<exception cref="InvalidOperationException">݂ <see cref="TaskTrigger.TriggerType"/>  <see cref="TaskSchedulers.TriggerType.Weekly"/> ł͂܂B</exception>
		///<returns>gK̏i[ <see cref="WeeklyTrigger"/> B</returns>
		public WeeklyTrigger GetAsWeekly() {
			if (this.TriggerType != TriggerType.Weekly)
				throw new InvalidOperationException("݂̃gK^Cv TriggerType.Weekly ł͂܂B");
			return this.union.Weekly;
		}
		///<summary>
		///<see cref="TaskTrigger.TriggerType"/>  <see cref="TaskSchedulers.TriggerType.MonthlyDate"/> ̂ƂȀi[Ă <see cref="MonthlyDateTrigger"/> 擾܂B
		///</summary>
		///<exception cref="InvalidOperationException">݂ <see cref="TaskTrigger.TriggerType"/>  <see cref="TaskSchedulers.TriggerType.MonthlyDate"/> ł͂܂B</exception>
		///<returns>gK̏i[ <see cref="MonthlyDateTrigger"/> B</returns>
		public MonthlyDateTrigger GetAsMonthlyDate() {
			if (this.TriggerType != TriggerType.MonthlyDate)
				throw new InvalidOperationException("݂̃gK^Cv TriggerType.MonthlyDate ł͂܂B");
			return this.union.MonthlyDate;
		}
		///<summary>
		///<see cref="TaskTrigger.TriggerType"/>  <see cref="TaskSchedulers.TriggerType.MonthlyDayOfWeek"/> ̂ƂȀi[Ă <see cref="MonthlyDayOfWeekTrigger"/> 擾܂B
		///</summary>
		///<exception cref="InvalidOperationException">݂ <see cref="TaskTrigger.TriggerType"/>  <see cref="TaskSchedulers.TriggerType.MonthlyDayOfWeek"/> ł͂܂B</exception>
		///<returns>gK̏i[ <see cref="MonthlyDayOfWeekTrigger"/> B</returns>
		public MonthlyDayOfWeekTrigger GetAsMonthlyDayOfWeek() {
			if (this.TriggerType != TriggerType.MonthlyDayOfWeek)
				throw new InvalidOperationException("݂̃gK^Cv TriggerType.MonthlyDayOfWeek ł͂܂B");
			return this.union.MonthlyDayOfWeek;
		}

		///<summary>
		///<see cref="ICloneable.Clone"/> ܂B
		///</summary>
		///<returns>̃CX^X̊ȈՃRs[B</returns>
		object ICloneable.Clone() {
			return this.MemberwiseClone();
		}
		///<summary>
		///̃CX^X̃Rs[쐬܂B<see cref="TaskTrigger"/> NX͎QƃoȂ߁ARs[悪Rs[ƓQƂoƂ͂܂B
		///</summary>
		///<returns>̃CX^X̃Rs[B</returns>
		public TaskTrigger Clone() {
			return (TaskTrigger)this.MemberwiseClone();
		}

		private short triggerSize = TaskTrigger.structSize;
		private short reserved1 = 0;
		private short beginYear; //WinXPł͏30827NBR͕sB
		private short beginMonth;
		private short beginDay;
		private short endYear;
		private short endMonth;
		private short endDay;
		private short startHour;
		private short startMinute;
		private int minutesDuration;
		private int minutesInterval;
		private TriggerFlags flags;
		private TriggerType triggerType;
		private TriggerTypeUnion union = new TriggerTypeUnion();
		private short reserved2 = 0;
		private short randomMinutesInterval = 0;

		private static readonly short structSize;
		static TaskTrigger() {
			structSize = (short)Marshal.SizeOf(typeof(TaskTrigger));
		}
	}
}
