// simplememory.cs /doc:CoTaskMem.xml /t:library
using System;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace HongliangSoft.Utilities.Unmanaged {
	///<summary>COM ^XNAP[^𗘗păA}l[Wh̃gp܂B</summary>
	public sealed class CoTaskMem : SimpleMemory {
		private IntPtr address;
		///<summary>̃CX^XwĂ|C^擾܂B</summary>
		public override IntPtr Address { get { return this.address; } }
		///<summary>
		///COM ^XNAP[^Aw肵TCỸubN蓖āA<see cref="CoTaskMem"/> CX^X܂B
		///</summary>
		///<param name="size">蓖Ă郁ubÑTCYB</param>
		///<exception cref="OutOfMemoryException"><paramref name="size"/> ɑ傫lA܂͕̒lw肵܂B</exception>
		///<remarks>
		///  <para>蓖ĂꂽubN̓el͕słB</para>
		///</remarks>
		public CoTaskMem(int size) {
			this.address = Marshal.AllocCoTaskMem(size);
		}
		///<summary>
		///w肵|C^ACOM ^XNAP[^犄蓖ĂꂽubNƂ <see cref="CoTaskMem"/> CX^X܂B
		///</summary>
		///<param name="ptr">̃CX^XɊ֘AÂ|C^\ System.IntPtr B</param>
		public CoTaskMem(IntPtr ptr) {
			this.address = ptr;
		}
		///<summary>
		///w肵|C^ACOM ^XNAP[^犄蓖ĂꂽubNƂ <see cref="CoTaskMem"/> CX^Xɕϊ܂B
		///</summary>
		///<param name="ptr">̃CX^XɊ֘AÂ|C^\ System.IntPtr B</param>
		///<returns>ϊ <see cref="CoTaskMem"/> B</returns>
		public static implicit operator CoTaskMem(IntPtr ptr) {
			return new CoTaskMem(ptr);
		}
		///<summary>
		///̃CX^XwĂ|C^ASystem.IntPtr ^̒lɕϊ܂B
		///</summary>
		///<param name="mem">ϊ|C^Ă <see cref="CoTaskMem"/> B</param>
		///<returns>ϊ System.IntPtr B</returns>
		public static implicit operator IntPtr(CoTaskMem mem) {
			return mem.Address;
		}
		///<summary>
		///̃CX^XĂ|C^܂B
		///</summary>
		///<param name="disposing">}l[WhIuWFNgꍇ true B</param>
		protected override void Dispose(bool disposing) {
			if (! this.Address.Equals(IntPtr.Zero)) {
				Marshal.FreeCoTaskMem(this.Address);
				this.address = IntPtr.Zero;
			}
		}
		///<summary>
		///񂩂 <see cref="CoTaskMem"/> 쐬܂BI[ NULL }܂B
		///</summary>
		///<param name="value">A}l[WhɊmۂ镶Bgp镶R[h̓vbgtH[Ɉˑ܂B</param>
		///<returns>쐬ꂽ <see cref="CoTaskMem"/> B</returns>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="value"/> ܂B</exception>
		///<exception cref="ArgumentNullException"><paramref name="value"/>  null w肵܂B</exception>
		public static CoTaskMem FromString(string value) {
			if (value == null)
				throw new ArgumentNullException("value", "null w肷邱Ƃ͂ł܂B");
			return new CoTaskMem(Marshal.StringToCoTaskMemAuto(value));
		}
		///<summary>
		///񂩂 <see cref="CoTaskMem"/> 쐬܂BI[ NULL }܂B
		///</summary>
		///<param name="value">A}l[WhɊmۂ镶B</param>
		///<param name="charSet">ϊɎgp镶ZbgB</param>
		///<returns>쐬ꂽ <see cref="CoTaskMem"/> B</returns>
		///<exception cref="ArgumentNullException"><paramref name="value"/>  null w肵܂B</exception>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="value"/> ܂B</exception>
		///<exception cref="InvalidEnumArgumentException"><paramref name="charSet"/> ɕsȒlw肳܂B</exception>
		public static CoTaskMem FromString(string value, CharSet charSet) {
			if (value == null)
				throw new ArgumentNullException("value", "null w肷邱Ƃ͂ł܂B");
			switch (charSet) {
			  case CharSet.Auto :
				return CoTaskMem.FromString(value);
			  case CharSet.Unicode :
				return new CoTaskMem(Marshal.StringToCoTaskMemUni(value));
			  case CharSet.Ansi :
			  case CharSet.None :
				return new CoTaskMem(Marshal.StringToCoTaskMemAnsi(value));
			  default :
				throw new InvalidEnumArgumentException("charSet", (int)charSet, typeof(CharSet));
			}
		}
		///<summary>
		///\̂ <see cref="CoTaskMem"/> 쐬܂B
		///</summary>
		///<param name="value">ɃRs[IuWFNg̃CX^XB<see cref="StructLayoutAttribute"/> <see cref="LayoutKind.Sequential"/> ܂ <see cref="LayoutKind.Explicit"/> w肵ĂNX̃CX^XłȂ΂Ȃ܂B</param>
		///<returns>쐬ꂽ <see cref="CoTaskMem"/> B</returns>
		///<exception cref="ArgumentNullException"><paramref name="value"/>  null w肵܂B</exception>
		///<exception cref="ArgumentException"><paramref name="value"/>  w肵IuWFNg <see cref="StructLayoutAttribute"/> <see cref="LayoutKind.Sequential"/> ܂ <see cref="LayoutKind.Explicit"/> w肳ĂȂAWFlbN^łB</exception>
		public static CoTaskMem FromStructure(object value) {
			if (value == null)
				throw new ArgumentNullException("value", "null w肷邱Ƃ͂ł܂B");
			IntPtr ptr = Marshal.AllocCoTaskMem(Marshal.SizeOf(value));
			Marshal.StructureToPtr(value, ptr, false);
			return new CoTaskMem(ptr);
		}
		///<summary>
		///oCgz񂩂 <see cref="CoTaskMem"/> 쐬܂B
		///</summary>
		///<param name="value">ɃRs[oCgzB</param>
		///<returns>쐬ꂽ <see cref="CoTaskMem"/> B</returns>
		///<exception cref="ArgumentNullException"><paramref name="value"/>  null w肵܂B</exception>
		public static CoTaskMem FromBytes(byte[] value) {
			if (value == null)
				throw new ArgumentNullException("value", "null w肷邱Ƃ͂ł܂B");
			IntPtr ptr = Marshal.AllocCoTaskMem(value.Length);
			Marshal.Copy(value, 0, ptr, value.Length);
			return new CoTaskMem(ptr);
		}
	}
}
