// unmanagedmemory.cs
using System;
using System.Collections;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Text;

namespace HongliangSoft.Utilities.Unmanaged {
	///<summary><see cref="Marshal"/> NX̊e\bhgpđsPȃubNɂĂ̊{񋟂钊ۃNXłB</summary>
	public abstract class SimpleMemory : UnmanagedMemory {
		///<summary>
		///CX^X܂B
		///</summary>
		protected SimpleMemory() : base() {
		}
		///<summary>
		///̃CX^XwĂ|C^ASystem.IntPtr ^̒lɕϊ܂B
		///</summary>
		///<param name="mem">|C^ɕϊ <see cref="SimpleMemory"/> B</param>
		///<returns>ϊꂽ|C^B|C^ NULL wĂꍇAIntPtr.Zero B</returns>
		public static implicit operator IntPtr(SimpleMemory mem) {
			return mem.Address;
		}
		///<summary>
		///̃CX^X̓eǂݏoāAw肵|C^ɏ݂܂B
		///</summary>
		///<param name="dest">ސ̃|C^B</param>
		///<param name="size">ǂݏo/݂sAoCgPʂ̃TCYB</param>
		///<param name="offset">̃CX^X|C^AhXɒǉoCgItZbgB</param>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="size"/> ܂<paramref name="offset"/>  0 lłB</exception>
		///<exception cref="InvalidOperationException">܂̃CX^XɃ|C^蓖ĂĂȂA܂͊ɉς݂łB</exception>
		public override void ReadToPtr(IntPtr dest, int size, int offset) {
			if (size < 0)
				throw new ArgumentOutOfRangeException("size", size, "TCY 0 邱Ƃ͂ł܂B");
			SimpleMemory.MoveMemory(dest, this.Offset(offset), new IntPtr(size));
		}
		///<summary>
		///̃CX^X̓eǂݎAoCgzŕԂ܂B
		///</summary>
		///<param name="length">ǂݎ钷B</param>
		///<param name="offset">̃CX^X|C^AhXɒǉoCgItZbgB</param>
		///<returns>ǂݎoCgzB</returns>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="length"/> ܂<paramref name="offset"/>  0 lłB</exception>
		///<exception cref="InvalidOperationException">܂̃CX^XɃ|C^蓖ĂĂȂA܂͊ɉς݂łB</exception>
		public override byte[] ReadBytes(int length, int offset) {
			if (length < 0)
				throw new ArgumentOutOfRangeException("length", length, " 0 邱Ƃ͂ł܂B");
			byte[] array = new byte[length];
			if (length == 0)
				return array;
			Marshal.Copy(this.Offset(offset), array, 0, length);
			return array;
		}
		///<summary>
		///̃CX^X̓eǂݎAw肵^̃CX^XƂĕԂ܂B
		///</summary>
		///<param name="type">ǂݎ^\ <see cref="Type"/> BŎw肷^ <see cref="StructLayoutAttribute"/>  <see cref="LayoutKind.Sequential"/> ܂ <see cref="LayoutKind.Explicit"/> Ń}[NĂȂ΂Ȃ܂B</param>
		///<param name="offset">̃CX^X|C^AhXɒǉoCgItZbgB</param>
		///<returns>ǂݎIuWFNgB</returns>
		///<exception cref="ArgumentNullException"><paramref name="type"/>  null w肳܂B</exception>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="offset"/>  0 lłB</exception>
		///<exception cref="ArgumentException"><paramref name="type"/>  <see cref="LayoutKind.Sequential"/> ܂ <see cref="LayoutKind.Explicit"/> ł͂܂B܂́A<paramref name="type"/> WFlbN^łB</exception>
		///<exception cref="InvalidOperationException">܂̃CX^XɃ|C^蓖ĂĂȂA܂͊ɉς݂łB</exception>
		public override object ReadStructure(Type type, int offset) {
			return Marshal.PtrToStructure(this.Offset(offset), type);
		}
#if !V10 && !V11
		///<summary>
		///̃CX^X̓eǂݎAw̃WFlbN^̃CX^XƂĕԂ܂B
		///</summary>
		///<typeparam name="TFormatted">ǂݎ^BŎw肷^ <see cref="StructLayoutAttribute"/>  <see cref="LayoutKind.Sequential"/> ܂ <see cref="LayoutKind.Explicit"/> Ń}[NĂȂ΂Ȃ܂B</typeparam>
		///<returns>ǂݎ <typeparamref name="TFormatted"/> ^̃IuWFNgB</returns>
		///<exception cref="ArgumentException"><typeparamref name="TFormatted"/>  <see cref="LayoutKind.Sequential"/> ܂ <see cref="LayoutKind.Explicit"/> ł͂܂B܂́A<typeparamref name="TFormatted"/> WFlbN^łB</exception>
		///<exception cref="InvalidOperationException">܂̃CX^XɃ|C^蓖ĂĂȂA܂͊ɉς݂łB</exception>
		///<exception cref="AccessViolationException">|C^sȃAhXwĂ܂B</exception>
		public override TFormatted ReadStructure<TFormatted>() {
			return (TFormatted)Marshal.PtrToStructure(this, typeof(TFormatted));
		}
		///<summary>
		///̃CX^X̓eǂݎAw̃WFlbN^̃CX^XƂĕԂ܂B
		///</summary>
		///<typeparam name="TFormatted">ǂݎ^BŎw肷^ <see cref="StructLayoutAttribute"/>  <see cref="LayoutKind.Sequential"/> ܂ <see cref="LayoutKind.Explicit"/> Ń}[NĂȂ΂Ȃ܂B</typeparam>
		///<param name="offset">̃CX^X|C^AhXɒǉoCgItZbgB</param>
		///<returns>ǂݎ <typeparamref name="TFormatted"/> ^̃IuWFNgB</returns>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="offset"/>  0 lłB</exception>
		///<exception cref="ArgumentException"><typeparamref name="TFormatted"/>  <see cref="LayoutKind.Sequential"/> ܂ <see cref="LayoutKind.Explicit"/> ł͂܂B܂́A<typeparamref name="TFormatted"/> WFlbN^łB</exception>
		///<exception cref="InvalidOperationException">܂̃CX^XɃ|C^蓖ĂĂȂA܂͊ɉς݂łB</exception>
		///<exception cref="AccessViolationException">|C^sȃAhXwĂ܂B</exception>
		public override TFormatted ReadStructure<TFormatted>(int offset) {
			return (TFormatted)Marshal.PtrToStructure(this.Offset(offset), typeof(TFormatted));
		}
#endif
		///<summary>
		///̃CX^X̓eǂݎAw肵Zbg̕ƂĕԂ܂B
		///</summary>
		///<param name="charSet">e𕶎ɕϊ邽߂̕Zbg\ <see cref="CharSet"/> B</param>
		///<param name="offset">̃CX^X|C^AhXɒǉoCgItZbgB</param>
		///<returns>ǂݎB</returns>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="offset"/>  0 lłB</exception>
		///<exception cref="InvalidOperationException">܂̃CX^XɃ|C^蓖ĂĂȂA܂͊ɉς݂łB</exception>
		///<exception cref="InvalidEnumArgumentException"><paramref name="charSet"/> ɕsȒlw肳܂B</exception>
		///<remarks>
		///  <para>NULL ̒O܂œǂݎ܂B</para>
		///</remarks>
		public override string ReadString(CharSet charSet, int offset) {
			switch (charSet) {
			  case CharSet.Auto :
				return Marshal.PtrToStringAuto(this.Offset(offset));
			  case CharSet.Unicode :
				return Marshal.PtrToStringUni(this.Offset(offset));
			  case CharSet.Ansi :
			  case CharSet.None :
				return Marshal.PtrToStringAnsi(this.Offset(offset));
			  default :
				throw new InvalidEnumArgumentException("charSet", (int)charSet, typeof(CharSet));
			}
		}
		///<summary>
		///̃CX^XɁAw肵IuWFNg̃oCg\݂܂B
		///</summary>
		///<param name="value">ރIuWFNgBŎw肷IuWFNǧ^ <see cref="StructLayoutAttribute"/>  <see cref="LayoutKind.Sequential"/> ܂ <see cref="LayoutKind.Explicit"/> Ń}[NĂȂ΂Ȃ܂B</param>
		///<param name="offset">̃CX^X|C^AhXɒǉoCgItZbgB</param>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="offset"/>  0 lłB</exception>
		///<exception cref="ArgumentException"><paramref name="type"/>  <see cref="LayoutKind.Sequential"/> ܂ <see cref="LayoutKind.Explicit"/> ł͂܂B܂́A<paramref name="type"/> WFlbN^łB</exception>
		///<exception cref="InvalidOperationException">܂̃CX^XɃ|C^蓖ĂĂȂA܂͊ɉς݂łB</exception>
		public override void Write(object value, int offset) {
			if (value == null)
				Marshal.WriteIntPtr(this.Offset(offset), IntPtr.Zero);
			else
				Marshal.StructureToPtr(value, this.Offset(offset), true);
		}
		///<summary>
		///̃CX^XɁAw肵oCgz݂܂B
		///</summary>
		///<param name="value">ރoCgzB</param>
		///<param name="offset">̃CX^X|C^AhXɒǉoCgItZbgB</param>
		///<exception cref="ArgumentNullException"><paramref name="value"/>  null w肳܂B</exception>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="offset"/>  0 lłB</exception>
		///<exception cref="InvalidOperationException">܂̃CX^XɃ|C^蓖ĂĂȂA܂͊ɉς݂łB</exception>
		public override void Write(byte[] value, int offset) {
			Marshal.Copy(value, 0, this.Offset(offset), value.Length);
		}
		///<summary>
		///̃CX^XɁAw肵|C^wl݂܂B
		///</summary>
		///<param name="ptr">ޒlwĂ|C^B</param>
		///<param name="size">ރTCYB</param>
		///<param name="offset">̃CX^X|C^AhXɒǉoCgItZbgB</param>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="size"/>  0 ܂ 0 lłB܂́A <paramref name="offset"/>  0 lłB</exception>
		///<exception cref="InvalidOperationException">܂̃CX^XɃ|C^蓖ĂĂȂA܂͊ɉς݂łB</exception>
		public override void Write(IntPtr ptr, int size, int offset) {
			if (size <= 0)
				throw new ArgumentOutOfRangeException("size", size, "TCY 0 ȉɂ邱Ƃ͂ł܂B");
			SimpleMemory.MoveMemory(this.Offset(offset), ptr, new IntPtr(size));
		}
		///<summary>
		///̃CX^XɁAw肵w肵Zbggpď݂܂B
		///</summary>
		///<param name="value">ޕB</param>
		///<param name="charSet">ޕoCgzɕϊ邽߂̕Zbg\ <see cref="CharSet"/> B</param>
		///<param name="offset">̃CX^X|C^AhXɒǉoCgItZbgB</param>
		///<returns>ۂɏ܂ꂽoCgBŌɉꂽNULL ̕܂݂܂B</returns>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="offset"/>  0 lłB</exception>
		///<exception cref="InvalidEnumArgumentException"><paramref name="charSet"/> ɕsȒlw肳܂B</exception>
		///<exception cref="InvalidOperationException">܂̃CX^XɃ|C^蓖ĂĂȂA܂͊ɉς݂łB</exception>
		///<remarks>
		///  <para>̃\bh́A̍ŌɎI NULL ܂B</para>
		///</remarks>
		public override int Write(string value, CharSet charSet, int offset) {
			byte[] data = null;
			switch (charSet) {
			  case CharSet.Auto :
				if (Marshal.SystemDefaultCharSize == 2)
					goto case CharSet.Unicode;
				else
					goto case CharSet.Ansi;
			  case CharSet.Unicode :
				data = Encoding.Unicode.GetBytes(value + "\0");
				break;
			  case CharSet.Ansi :
				data = Encoding.Default.GetBytes(value + "\0");
				break;
			  default :
				throw new InvalidEnumArgumentException("charSet", (int)charSet, typeof(CharSet));
			}
			this.Write(data, offset);
			return data.Length;
		}

		///<summary>
		///̃CX^X́Aw肵TCŸ̗ 0 Ŗ߂܂B
		///</summary>
		///<param name="size">0 Ŗ߂TCYB</param>
		///<param name="offset">̃CX^X|C^AhXɒǉoCgItZbgB</param>
		///<exception cref="ArgumentOutOfRangeException"><paramref name="size"/> ܂ <paramref name="offset"/>  0 lłB</exception>
		///<exception cref="InvalidOperationException">܂̃CX^XɃ|C^蓖ĂĂȂA܂͊ɉς݂łB</exception>
		public override void Clear(int size, int offset) {
			if (size < 0)
				throw new ArgumentOutOfRangeException("size", size, "TCY 0 lɂ邱Ƃ͂ł܂B");
			this.Write(new byte[size], offset);
		}

		[DllImport("kernel32.dll", SetLastError=true)]
		private static extern void MoveMemory(IntPtr dest, IntPtr source, IntPtr size);
	}
}
